//--------------------
// Name: CityRP
// Type: RP
// Version: 1.4B
// Author: Jookia
//--------------------

// Update 1.1
//  Fixed a real estate bug.
//  No longer can reset while having a loan.
//  Updated the bank disclaimer.
//  Added ^cast command.
//  Save file is generated at start.
//  Added a few missing prefs.
//  Fixed a bug with not being able to see bottomprint when first spawned.

// Update 1.2
//  Added a datablock.CityRPCanSpawn variable.
//  Changing maps keeps minigame.
//  Default interest set to 1.01.

// Update 1.3
//  Added some RTB stuff.

// Update 1.4
//  Revamped jobs system.
//  Commands go into the commands.cs file.

// Update 1.4B
//  Fixed jobs system.
//  Input bricks go into the inputBricks.cs file.

package CityRP
{
	function CityRP(%mode, %data)
	{
		if(%mode == 1)
		{
			if(!isObject(CityRPData))
			{
				new scriptObject(CityRPData)
				{
					class = Sassy;
					
					dataFile = "config/server/PeopleMods/CityRPData.dat";
				};
				
				// I'm sorry, but your jobs are in another castle.
				
				$CityRP::prices::vehicleSpawn = 500;
				$CityRP::prices::addItemSpawn = 25;
				$CityRP::prices::jailingBonus = 100;
				$CityRP::prices::reset = 100;
				$CityRP::prices::maxLoan = 1000;
				$CityRP::prices::loanPay = 25;
				
				$CityRP::demerits::demoteLevel = 50000;
				$CityRP::demerits::wantedLevel = 50;
				$CityRP::demerits::pickpocketing = 60;
				$CityRP::demerits::hittingInnocents = 100;
				$CityRP::demerits::attemptedMurder = 25;
				$CityRP::demerits::murder = 200;
				
				$CityRP::other::tickSpeed = 1;
				$CityRP::other::interest = 1.02;
				$CityRP::other::interestTick = 5;
				$CityRP::other::maxInterest = 10000;
				$CityRP::other::commandSymbol = "^";
				
				if(isFile("config/server/PeopleMods/CityRPPrefs.cs"))
				{
					exec("config/server/PeopleMods/CityRPPrefs.cs");
				}
				
				export("$CityRP::*", "config/server/PeopleMods/CityRPPrefs.cs", false);
				
				$CityRP_temp::spawnPoints = "";
				$CityRP_temp::loadedDatablocks = true;
				
				exec("config/server/PeopleMods/CityRPPrefs.cs");
				
				if(isFile("add-ons/system_ReturnToBlockland/server.cs") && !$CityRP_temp::loadedRTBPrefs)
				{
					if(!$RTB::RTBS_ServerControl)
					{
						exec("add-ons/system_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
					}
					
					RTB_registerPref("Demote Demerits", "CityRP", "$CityRP::demerits::demoteLevel", "int 1 1000", "CityRP", $CityRP::demerits::demoteLevel, false, false);
					RTB_registerPref("Wanted Demerits", "CityRP", "$CityRP::demerits::wantedLevel", "int 1 1000", "CityRP", $CityRP::demerits::wantedLevel, false, false);
					RTB_registerPref("Pickpocket Demerits", "CityRP", "$CityRP::demerits::pickpocketing", "int 1 1000", "CityRP", $CityRP::demerits::pickpocketing, false, false);
					RTB_registerPref("Hitting Innocent Demerits", "CityRP", "$CityRP::demerits::hittingInnocents", "int 1 1000", "CityRP", $CityRP::demerits::hittingInnocents, false, false);
					RTB_registerPref("Attempted Murder Demerits", "CityRP", "$CityRP::demerits::attemptedMurder", "int 1 1000", "CityRP", $CityRP::demerits::attemptedMurder, false, false);
					RTB_registerPref("Murder Demerits", "CityRP", "$CityRP::demerits::murder", "int 1 1000", "CityRP", $CityRP::demerits::murder, false, false);
					
					RTB_registerPref("Vehicle Spawn Price", "CityRP", "$CityRP::prices::vehicleSpawn", "int 0 10000", "CityRP", $CityRP::prices::vehicleSpawn, false, true);
					RTB_registerPref("Base Item Spawn Price", "CityRP", "$CityRP::prices::addItemSpawn", "int 0 10000", "CityRP", $CityRP::prices::addItemSpawn, false, true);
					RTB_registerPref("Jailing Bonus Price", "CityRP", "$CityRP::prices::jailingBonus", "int 0 10000", "CityRP", $CityRP::prices::jailingBonus, false, true);
					RTB_registerPref("Reset Price", "CityRP", "$CityRP::prices::reset", "int 0 10000", "CityRP", $CityRP::prices::reset, false, true);
					RTB_registerPref("Maximum Loan", "CityRP", "$CityRP::prices::maxLoan", "int 0 10000", "CityRP", $CityRP::prices::maxLoan, false, true);
					RTB_registerPref("Loan Pay", "CityRP", "$CityRP::prices::loanPay", "int 0 10000", "CityRP", $CityRP::prices::loanPay, false, true);
					
					RTB_registerPref("Tick Speed", "CityRP", "$CityRP::other::tickSpeed", "int 1 10", "CityRP", $CityRP::other::tickSpeed, false, true);
					RTB_registerPref("Interest", "CityRP", "$CityRP::other::interest", "int 0 5", "CityRP", $CityRP::other::interest, false, true);
					RTB_registerPref("Interest Stop", "CityRP", "$CityRP::other::maxInterest", "int 0 100000", "CityRP", $CityRP::other::maxInterest, false, true);
					RTB_registerPref("Interest Tick", "CityRP", "$CityRP::other::interestTick", "int 0 100", "CityRP", $CityRP::other::interestTick, false, true);
					
					activatePackage(RTB_Goodies);
					
					$CityRP_temp::loadedRTBPrefs = true;
				}
				
				exec("./commands.cs");
				exec("./inputBricks.cs");
				
				Sassy_loadPrefArray(findFirstFile("./jobs.dat"));
				
				if(CityRPData.valueCount == 0)
				{
					CityRPData.addValue("money", 200);
					CityRPData.addValue("jobID", 1);
					CityRPData.addValue("demerits", 0);
					
					CityRPData.addValue("bankData", "0 0 0");
					CityRPData.addValue("jailData", "0 0");
					CityRPData.addValue("lotData", "0");
					
					CityRPData.saveData();
				}
				else
				{
					for(%a = 1; %a <= CityRPData.dataCount; %a++)
					{
						if(CityRPData.data[%a].valueJobID > $CityRP::jobs || CityRPData.data[%a].valueJobID < 0)
						{
							CityRPData.data[%a].valueJobID = 1;
						}
					}
				}
				
				registerInputEvent("fxDTSBrick", "onEnterLot", "Self fxDTSBrick\tPlayer player\tClient gameConnection\tMiniGame miniGame");
				registerInputEvent("fxDTSBrick", "onLeaveLot", "Self fxDTSBrick\tPlayer player\tClient gameConnection\tMiniGame miniGame");
				
				CityRPData.tickCount = 0;
				
				CityRPData.scheduleTick = schedule($CityRP::other::tickSpeed * 60000, false, "CityRP", 2);
			}
			else
			{
				for(%a = 1; %a <= CityRPData.dataCount; %a++)
				{
					if(CityRPData.data[%a].valueJobID > $CityRP::jobs || CityRPData.data[%a].valueJobID < 0)
					{
						CityRPData.data[%a].valueJobID = 0;
					}
				}
			}
			
			if(!isObject(CityRPHelp))
			{
				new scriptObject(CityRPHelp)
				{
					class = Hellen;
				};
			}
			
			if(!isObject(CityRPMini))
			{
				new scriptObject(CityRPMini)
				{
					class = miniGameSO;
					
					brickDamage = true;
					brickRespawnTime = 10000;
					colorIdx = -1;
					
					enableBuilding = true;
					enablePainting = true;
					enableWand = true;
					fallingDamage = false;
					inviteOnly = true;
					
					points_plantBrick = 0;
					points_breakBrick = 0;
					points_die = -1;
					points_killPlayer = 1;
					points_killSelf = -1;
					
					playerDatablock = playerNoJet;
					respawnTime = 2000;
					selfDamage = true;
					
					playersUseOwnBricks = false;
					useAllPlayersBricks = true;
					useSpawnBricks = false;
					VehicleDamage = true;
					vehicleRespawnTime = 5000;
					weaponDamage = true;
					
					numMembers = 0;
				};
			}
			
			for(%a = 1; %a <= $CityRP::jobs; %a++)
			{
				if(isObject("CityRPJob" @ %a @ "SpawnBrickData"))
				{
					continue;
				}
				
				datablock fxDtsBrickData(CityRPSpawnBrickData : brickSpawnPointData)
				{
					category = "PeopleMods";
					subCategory = "CityRP Admin";
					
					uiName = $CityRP::jobs::name[%a] SPC "Spawn";
					
					specialBrickType = "";
					
					CityRPBrickType = 3;
					CityRPBrickAdmin = true;
					
					spawnData = "jobSpawn" SPC %a;
				};
				
				CityRPSpawnBrickData.setName("CityRPJob" @ %a @ "SpawnBrickData");
			}
		}
		
		if(%mode == 2)
		{
			if(CityRPData.scheduleTick)
			{
				cancel(CityRPData.scheduleTick);
			}
			
			CityRPData.tickCount++;
			
			for(%a = 0; %a <= CityRPData.dataCount; %a++)
			{
				if(CityRPData.tickCount % $CityRP::other::interestTick == 0 && getWord(CityRPData.data[%a].valueBankData, 0) < $CityRP::other::maxInterest)
				{
					CityRPData.data[%a].valueBankData = mFloor(getWord(CityRPData.data[%a].valueBankData, 0) * $CityRP::other::interest) SPC getWords(CityRPData.data[%a].valueBankData, 1, 2);
				}
				
				if(!isObject(findClientByBL_ID(CityRPData.data[%a].ID)))
				{
					continue;
				}
				
				%client = findClientByBL_ID(CityRPData.data[%a].ID);
				
				if(getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) > 0)
				{
					CityRPData.getData(%client.bl_id).valueJailData = 1 SPC getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) - 1;
					
					if(getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) < 1)
					{
						messageClient(%client, '', "\c6You're free.");
						
						if(isObject(%client.player))
						{
							%client.player.delete();
							%client.spawnPlayer();
						}
						
						continue;
					}
					
					messageClient(%client, '', "\c6You now have \c3" @ getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) SPC "\c6tick" @ ((getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) == 1) ? "" : "s") SPC "until you get out of jail.");
					
					%client.CityRP(1);
					
					continue;
				}
				
				if($CityRP::jobs::pay[CityRPData.getData(%client.bl_id).valueJobID] > 0)
				{
					CityRPData.getData(%client.bl_id).valueMoney += $CityRP::jobs::pay[CityRPData.getData(%client.bl_id).valueJobID];
					
					messageClient(%client, '', "\c6You have been paid \c3$" @ $CityRP::jobs::pay[CityRPData.getData(%client.bl_id).valueJobID] @ "\c6.");
				}
				
				if(%client.brickGroup.taxes > 0)
				{
					CityRPData.getData(%client.bl_id).valueMoney -= %client.brickGroup.taxes;
					
					if(CityRPData.getData(%client.bl_id).valueMoney < 0)
					{
						CityRPData.getData(%client.bl_id).valueMoney = 0;
					}
					
					messageClient(%client, '', "\c6You have paid \c3$" @ %client.brickGroup.taxes SPC "\c6in taxes.");
				}
				
				if(getWord(CityRPData.getData(%client.bl_id).valueBankData, 2) > 0 && CityRPData.getData(%client.bl_id).valueMoney > 0)
				{
					%paid = $CityRP::prices::loanPay;
					
					if(getWord(CityRPData.getData(%client.bl_id).valueBankData, 1) < $CityRP::prices::loanPay)
					{
						%paid = getWord(CityRPData.getData(%client.bl_id).valueBankData, 1);
					}
					
					if(CityRPData.getData(%client.bl_id).valueMoney < %paid)
					{
						%paid = CityRPData.getData(%client.bl_id).valueMoney;
					}
					
					messageClient(%client, '', "\c6You have paid \c3$" @ %paid SPC "\c6towards your loan.");
					
					CityRPData.getData(%client.bl_id).valueMoney -= %paid;
					
					if(getWord(CityRPData.getData(%client.bl_id).valueBankData, 1) - %paid < 1)
					{
						CityRPData.getData(%client.bl_id).valueBankData = getWord(CityRPData.getData(%client.bl_id).valueBankData, 0) SPC 0 SPC 0;
					}
					else
					{
						CityRPData.getData(%client.bl_id).valueBankData = getWord(CityRPData.getData(%client.bl_id).valueBankData, 0) SPC getWord(CityRPData.getData(%client.bl_id).valueBankData, 1) - %paid SPC getWord(CityRPData.getData(%client.bl_id).valueBankData, 2);
					}
				}
				
				%client.CityRP(1);
			}
			
			CityRPData.saveData();
			
			CityRPData.scheduleTick = schedule($CityRP::other::tickSpeed * 60000, false, "CityRP", 2);
		}
		
		if(%mode == 3)
		{
			%letter = strLwr(getSubStr(%data, 0, 1));
			
			if(%letter $= "a" || %letter $= "e" || %letter $= "i" || %letter $= "o" || %letter $= "u")
			{
				return "an";
			}
			
			return "a";
		}
		
		if(%mode == 4)
		{
			for(%a = 0; %a < getWordCount($CityRP_temp::spawnPoints); %a++)
			{
				%brick = getWord($CityRP_temp::spawnPoints, %a);
				
				if(strLwr(%brick.getDatablock().spawnData) !$= strLwr(%data) && getWord(strLwr(%data), 0) !$= strLwr("personalSpawn"))
				{
					continue;
				}
				
				if(getWord(strLwr(%data), 0) $= strLwr("personalSpawn") && (strLwr(%brick.getDatablock().spawnData) !$= strLwr("personalSpawn") || getBrickGroupFromObject(%brick).bl_id != getWord(strLwr(%data), 1)))
				{
					continue;
				}
				
				%possibleSpawns = (%possibleSpawns $= "") ? %brick : %possibleSpawns SPC %brick;
			}
			
			if(%possibleSpawns !$= "")
			{
				%spawnBrick = getWord(%possibleSpawns, getRandom(0, getWordCount(%possibleSpawns) - 1));
				
				return vectorSub(%spawnBrick.getWorldBoxCenter(), "0 0" SPC (%spawnBrick.getDatablock().brickSizeZ - 3) * 0.1) SPC getWords(%spawnBrick.getTransform(), 3, 6);
			}
			
			return false;
		}
	}
	
	function fxDtsBrick::CityRP(%brick, %mode, %data)
	{
		if(%mode == 1 && !isObject(%brick.trigger))
		{
			%datablock = %brick.getDatablock();
			
			%scale = getWord(%datablock.triggerSize, 0) / 2 SPC getWord(%datablock.triggerSize, 1) / 2 SPC getWord(%datablock.triggerSize, 2) / 2;
			
			if(mFloor(getWord(%brick.rotation, 3)) == 90)
			{
				%scale = getWord(%datablock.triggerSize, 1) / 2 SPC getWord(%datablock.triggerSize, 0) / 2 SPC getWord(%datablock.triggerSize, 2) / 2;
			}
			
			%brick.trigger = new trigger()
			{
				datablock = %datablock.triggerDatablock;
				
				position = getWords(%brick.getWorldBoxCenter(), 0, 1) SPC getWord(%brick.getWorldBoxCenter(), 2) + ((getWord(%datablock.triggerSize, 2) / 4) + (%datablock.brickSizeZ * 0.1));
				rotation = "1 0 0 0";
				scale = %scale;
				
				polyhedron = "-0.5000000 -0.5000000 -0.5000000 1.0000000 0.0000000 0.0000000 0.0000000 1.0000000 0.0000000 0.0000000 0.0000000 1.0000000";
				
				parent = %brick;
			};
			
			if(%brick.getDatablock().CityRPBrickType == 1)
			{
				%boxSize = getWord(%scale, 0) / 2.5 SPC getWord(%scale, 1) / 2.5 SPC getWord(%scale, 2) / 2.5;
				
				initContainerBoxSearch(%brick.trigger.getWorldBoxCenter(), %boxSize, $typeMasks::playerObjectType);
				
				while(isObject(%player = containerSearchNext()))
				{
					%brick.trigger.getDatablock().onEnterTrigger(%brick.trigger, %player);
				}
				
				getBrickGroupFromObject(%brick).taxes += %brick.getDatablock().taxAmount;
				
				if(isObject(getBrickGroupFromObject(%brick).client))
				{
					getBrickGroupFromObject(%brick).client.CityRP(1);
				}
			}
		}
		
		if(%mode == 2 && isObject(%brick.trigger))
		{
			for(%a = 0; %a < clientGroup.getCount(); %a++)
			{
				if(isObject(clientGroup.getObject(%a).player) && clientGroup.getObject(%a).CityRPTrigger == %brick.trigger)
				{
					%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, clientGroup.getObject(%a).player, true);
				}
			}
			
			%boxSize = getWord(%brick.trigger.scale, 0) / 2.5 SPC getWord(%brick.trigger.scale, 1) / 2.5 SPC getWord(%brick.trigger.scale, 2) / 2.5;
			
			initContainerBoxSearch(%brick.trigger.getWorldBoxCenter(), %boxSize, $typeMasks::playerObjectType);
			
			while(isObject(%player = containerSearchNext()))
			{
				%brick.trigger.getDatablock().onLeaveTrigger(%brick.trigger, %player);
			}
			
			%brick.trigger.delete();
			
			if(%brick.getDatablock().CityRPBrickType == 1)
			{
				getBrickGroupFromObject(%brick).taxes -= %brick.getDatablock().taxAmount;
				
				if(isObject(getBrickGroupFromObject(%brick).client))
				{
					getBrickGroupFromObject(%brick).client.CityRP(1);
				}
				
				if(%brick.getName() !$= "")
				{
					%data = CityRPData.getData(getBrickGroupFromObject(%brick).bl_id).valueLotData;
					
					%newData = getWord(%data, 0) - 1;
					
					for(%a = 1; %a < getWordCount(%data); %a++)
					{
						if(%cancelNext)
						{
							%cancelNext = false;
							
							continue;
						}
						
						%newData = %newData SPC getWord(%data, %a);
						
						if(%a % 2 == 0)
						{
							continue;
						}
						
						%newBrick = "_" @ getWord(%data, %a);
						
						if(isObject(%newBrick) && %newBrick $= %brick.getName())
						{
							%found = true;
							
							%newData = getWords(%newData, 0, getWordCount(%newData) - 2);
							
							%cancelNext = true;
						}
					}
					
					if(%found)
					{
						CityRPData.getData(getBrickGroupFromObject(%brick).bl_id).valueLotData = %newData;
					}
				}
			}
		}
		
		if(%mode == 3)
		{
			if(isObject(%data) && getWord(%data, 1))
			{
				if(strReplace(%data.brickList, %brick, "") !$= %data.brickList)
				{
					return;
				}
				
				%data.brickCount++;
				%data.brickList = %data.brickList SPC %brick;
				
				for(%a = 0; %a < %brick.getNumUpBricks(); %a++)
				{
					%brick.getUpBrick(%a).CityRP(3, %data SPC 1);
				}
				
				for(%b = 0; %b < %brick.getNumDownBricks(); %b++)
				{
					%brick.getDownBrick(%b).CityRP(3, %data SPC 1);
				}
				
				return;
			}
			
			getBrickGroupFromObject(%brick).taxes -= %brick.getDatablock().taxAmount;
			
			%data.taxes += %brick.getDatablock().taxAmount;
			
			if(isObject(getBrickGroupFromObject(%brick).client))
			{
				getBrickGroupFromObject(%brick).client.CityRP(1);
			}
			
			if(isObject(%data.client))
			{
				%data.client.CityRP(1);
			}
			
			%dataStore = new scriptObject()
			{
				brickCount = 1;
				
				brickList = %brick;
			};
			
			for(%a = 0; %a < %brick.getNumUpBricks(); %a++)
			{
				%brick.getUpBrick(%a).CityRP(3, %dataStore SPC 1);
			}
			
			for(%b = 0; %b < %dataStore.brickCount; %b++)
			{
				%brick = getWord(%dataStore.brickList, %b);
				%oldGroup = getBrickGroupFromObject(%brick);
				
				%oldGroup.remove(%brick);
				%data.add(%brick);
				
				if(%brick.getName() !$= "")
				{
					%name = %brick.getName();
					
					%oldGroup.removeNTName(%name);
					%data.addNTName(%name);
				}
			}
			
			%dataStore.delete();
			
			%boxSize = getWord(%brick.trigger.scale, 0) / 2.5 SPC getWord(%brick.trigger.scale, 1) / 2.5 SPC getWord(%brick.trigger.scale, 2) / 2.5;
			
			initContainerBoxSearch(%brick.trigger.getWorldBoxCenter(), %boxSize, $typeMasks::playerObjectType);
			
			while(isObject(%player = containerSearchNext()))
			{
				if(isObject(%player.client))
				{
					%player.client.CityRP(1);
				}
			}
		}
	}
	
	function gameConnection::CityRP(%this, %mode, %data)
	{
		if(%mode == 1)
		{
			if(isObject(%this.player))
			{
				%tag = $CityRP::jobs::name[CityRPData.getData(%this.bl_id).valueJobID];
				
				if(getWord(CityRPData.getData(%this.bl_id).valueJailData, 1) > 0)
				{
					%tag = getWord(CityRPData.getData(%this.bl_id).valueJailData, 1) SPC "\c6Tick" @ ((getWord(CityRPData.getData(%this.bl_id).valueJailData, 1) == 1) ? "" : "s");
				}
				
				%this.player.setShapeName("[" @ %tag @ "]" SPC %this.name);
			}
			
			%this.CityRPPrint = "\c6Money: \c3$" @ CityRPData.getData(%this.bl_id).valueMoney SPC "\c6Job: \c3" @ $CityRP::jobs::name[CityRPData.getData(%this.bl_id).valueJobID] SPC "\c6Income: \c3$" @ $CityRP::jobs::pay[CityRPData.getData(%this.bl_id).valueJobID] SPC "\c6Taxes: \c3$" @ ((%this.brickGroup.taxes > 0) ? %this.brickGroup.taxes : "0") @ (isObject(%this.CityRPLotTrigger) ? "<just:right>\c6Owner: \c3" @ getBrickGroupFromObject(%this.CityRPLotTrigger.parent).name : "");
			
			commandToClient(%this, 'bottomPrint', %this.cityRPPrint);
		}
		
		if(%mode == 2)
		{
			if(getWord(CityRPData.getData(%this.bl_id).valueJailData, 1) > 0)
			{
				return;
			}
			
			%demerits = mFloor(%data);
			%currentDemerits = CityRPData.getData(%this.bl_id).valueDemerits;
			
			CityRPData.getData(%this.bl_id).valueDemerits += %demerits;
			
			if(CityRPData.getData(%this.bl_id).valueDemerits >= $CityRP::demerits::demoteLevel)
			{
				CityRPData.getData(%this.bl_id).valueJailData = 1 SPC 0;
				
				if(!$CityRP::jobs::law[CityRPData.getData(%this.bl_id).valueJobID])
				{
					return;
				}
				
				messageClient(%this, '', "\c6You have been demoted to" SPC CityRP(3, $CityRP::jobs::name[1]) SPC "\c3" @ $CityRP::jobs::name[1] @ "\c6.");
				
				CityRPData.getData(%this.bl_id).valueJobID = 1;
				
				%this.CityRP(1);
				
				if(isObject(%this.player))
				{
					serverCmdunUseTool(%this);
					
					%this.player.giveDefaultEquipment();
				}
			}
		}
		
		if(%mode == 3)
		{
			%rawTicks = (mFloor(CityRPData.getData(%this.bl_id).valueDemerits / ($CityRP::other::tickSpeed * 50)) > 0) ? mFloor(CityRPData.getData(%this.bl_id).valueDemerits / ($CityRP::other::tickSpeed * 50)) : 1;
			
			%ticks = %rawTicks;
			
			if(%ticks > 2)
			{
				%ticks = 2;
			}
			
			messageAll('', "\c3" @ %data.name SPC "\c6has jailed \c3" @ %this.name SPC "\c6for \c3" @ %ticks SPC"\c6tick" @ ((%ticks == 1) ? "" : "s") @ ".", 5);
			commandToClient(%this, 'centerPrint', "\c3" @ %data.name SPC "\c6has jailed you for \c3" @ %ticks SPC"\c6tick" @ ((%ticks == 1) ? "" : "s") @ ".", 5);
			commandToClient(%data, 'centerPrint', "\c6You have jailed \c3" @ %this.name SPC "\c6for \c3" @ %ticks SPC"\c6tick" @ ((%ticks == 1) ? "" : "s") @ ". You now have \c3$" @ CityRPData.getData(%data.bl_id).valueMoney + ($CityRP::prices::jailingBonus * %ticks) @ "\c6.", 5);
			
			CityRPData.getData(%this.bl_id).valueJailData = 1 SPC %ticks;
			CityRPData.getData(%this.bl_id).valueDemerits = 0;
			
			CityRPData.getData(%data.bl_id).valueMoney += $CityRP::prices::jailingBonus * %ticks;
			
			%data.CityRP(1);
			
			if($CityRP::jobs::law[CityRPData.getData(%this.bl_id).valueJobID])
			{
				messageClient(%this, '', "\c6You have been demoted to" SPC CityRP(3, $CityRP::jobs::name[1]) SPC "\c3" @ $CityRP::jobs::name[1] SPC "\c6since you were jailed.");
				
				CityRPData.getData(%this.bl_id).valueJobID = 1;
			}
			
			if(isObject(%this.player.tempBrick))
			{
				%this.player.tempBrick.delete();
			}
			
			%this.player.delete();
			%this.spawnPlayer();
		}
	}
	
	function gameConnection::onClientEnterGame(%this)
	{
		parent::onClientEnterGame(%this);
		
		if(!isObject(CityRPData.getData(%this.bl_id)))
		{
			CityRPData.addData(%this.bl_id);
		}
		
		%this.CityRP(1);
	}
	
	function gameConnection::spawnPlayer(%this)
	{
		parent::spawnPlayer(%this);
		
		if(CityRP(4, "jobSpawn 1"))
		{
			%spawn = CityRP(4, "jobSpawn 1");
		}
		
		if(CityRP(4, "jobSpawn" SPC CityRPData.getData(%this.bl_id).valueJobID))
		{
			%spawn = CityRP(4, "jobSpawn" SPC CityRPData.getData(%this.bl_id).valueJobID);
		}
		
		if(CityRP(4, "personalSpawn" SPC %this.bl_id))
		{
			%spawn = CityRP(4, "personalSpawn" SPC %this.bl_id);
		}
		
		if(getWord(CityRPData.getData(%this.bl_id).valueJailData, 1) > 0 && CityRP(4, "jailSpawn"))
		{
			%spawn = CityRP(4, "jailSpawn");
		}
		
		if(%spawn !$= "")
		{
			%this.player.setTransform(%spawn);
		}
		
		%this.player.giveDefaultEquipment();
		
		if(!isObject(CityRPMini))
		{
			CityRP(1);
		}
		
		CityRPMini.addMember(%this);
	}
	
	function gameConnection::onDeath(%this, %killerPlayer, %killer, %damageType, %damageLoc)
	{
		if(isObject(%this.CityRPTrigger))
		{
			%this.CityRPTrigger.getDatablock().onLeaveTrigger(%this.CityRPTrigger, %this.player);
		}
		
		if(isObject(%this.CityRPLotTrigger))
		{
			%this.CityRPLotTrigger.getDatablock().onLeaveTrigger(%this.CityRPLotTrigger, %this.player);
		}
		
		%this.CityRP(1);
		
		if(getWord(CityRPData.getData(%this.bl_id).valueJailData, 1) < 1)
		{
			if(%this.player.currTool)
			{
				serverCmddropTool(%this, %this.player.currTool);
			}
			
			if(isObject(%killer) && %killer != %this)
			{
				commandToClient(%killer, 'centerPrint', "\c6You have commited a crime. [\c3Murder\c6]", 1);
				
				%killer.CityRP(2, $CityRP::demerits::murder);
			}
		}
		
		parent::onDeath(%this, %this, %killer, %damageType, %unknownA);
	}
	
	function serverCmdmessageSent(%client, %text)
	{
		if(getSubStr(%text, 0, 1) $= $CityRP::other::commandSymbol)
		{
			if(%client.lastCityRPCommand + 0.01 > $sim::time)
				return;
			
			%command = getWord(getSubStr(%text, 1, strLen(%text) - 1), 0);
			%args = getSubStr(%text, strLen(%command) + 2, strLen(%text) - 1);
			
			%lastCommand = %client.lastCityRPCommand;
			%client.lastCityRPCommand = $sim::time;
			
			if(isFunction("CityRP_" @ %command) == 0)
				messageClient(%client, '', "\c6Invalid command '\c3" @ %command @ "\c6'.");
			else
			{
				call("CityRP_" @ %command, %client, %command, %args);
				%client.lastCityRPCommand = %lastCommand;
			}
			
			return;
		}
		
		if(isObject(%client.player) && isObject(%client.CityRPTrigger) && isObject(%client.CityRPTrigger.parent) && %client.CityRPTrigger.parent.getDatablock().CityRPBrickType == 2)
		{
			if(%client.lastCityRPCommand + 0.01 > $sim::time)
			{
				return;
			}
			
			%client.CityRPTrigger.parent.getDatablock().parseData(%client.CityRPTrigger.parent, %client, "", %text);
			
			%client.lastCityRPCommand = $sim::time;
			
			return;
		}
		
		if(getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) > 0)
		{
			messageClient(%client, '', "\c6You can't talk while in jail.");
			
			return;
		}
		
		parent::serverCmdmessageSent(%client, %text);
	}
	
	function serverCmdteamMessageSent(%client, %text)
	{
		%minigame = %client.minigame;
		%client.minigame = "";
		
		parent::serverCmdteamMessageSent(%client, %text);
		
		%client.minigame = %minigame;
	}
	
	function serverCmdcreateMiniGame(%client)
	{
		return;
	}
	
	function serverCmdleaveMiniGame(%client)
	{
		return;
	}
	
	function serverCmddropTool(%client, %toolID)
	{
		if(getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) > 0)
		{
			messageClient(%client, '', "\c6You can't drop tools while in jail.");
			
			return;
		}
		
		parent::serverCmddropTool(%client, %toolID);
	}
	
	function serverCmdsuicide(%client)
	{
		if(getWord(CityRPData.getData(%client.bl_id).valueJailData, 1) > 0)
		{
			messageClient(%client, '', "\c6You can't suicide while in jail.");
			
			return;
		}
		
		parent::serverCmdsuicide(%client);
	}
	
	function fxDtsBrick::onPlant(%brick)
	{
		parent::onPlant(%brick);
		
		if(isObject($loadingBricks_client) && !isObject($loadBrick_fileObj))
		{
			if(%brick.getDatablock().CityRPBrickType == 1 || %brick.getDatablock().CityRPBrickType == 2)
			{
				%brick.schedule(1, "CityRP", 1);
			}
			
			if(%brick.getDatablock().CityRPBrickType == 3)
			{
				$CityRP_temp::spawnPoints = ($CityRP_temp::spawnPoints $= "") ? %brick : $CityRP_temp::spawnPoints SPC %brick;
			}
			
			return;
		}
		
		if(!isObject(getBrickGroupFromObject(%brick).client))
		{
			if(%brick.getDatablock().CityRPBrickType == 1)
			{
				%brick.schedule(0, "delete");
			}
			
			if(%brick.getDatablock().CityRPBrickType == 2)
			{
				%brick.schedule(0, "CityRP", 1);
			}
			
			if(%brick.getDatablock().CityRPBrickType == 3)
			{
				$CityRP_temp::spawnPoints = ($CityRP_temp::spawnPoints $= "") ? %brick : $CityRP_temp::spawnPoints SPC %brick;
			}
			
			return;
		}
		
		%boxSize = getWord(%brick.getDatablock().brickSizeX, 1) / 2.5 SPC getWord(%brick.getDatablock().brickSizeY, 0) / 2.5 SPC getWord(%brick.getDatablock().brickSizeZ, 2) / 2.5;
		
		if(mFloor(getWord(%brick.rotation, 3)) == 90)
		{
			%boxSize = getWord(%brick.getDatablock().brickSizeY, 1) / 2.5 SPC getWord(%brick.getDatablock().brickSizeX, 0) / 2.5 SPC getWord(%brick.getDatablock().brickSizeZ, 2) / 2.5;
		}
		
		%client = getBrickGroupFromObject(%brick).client;
		
		initContainerBoxSearch(%brick.getWorldBoxCenter(), %boxSize, $typeMasks::triggerObjectType);
		
		while(isObject(%potentialTrigger = containerSearchNext()))
		{
			%trigger = %potentialTrigger;
			
			if(%trigger.getDatablock() == CityRPLotTriggerData.getID())
			{
				if(%brick.getDatablock().CityRPBrickType == 1)
				{
					%brick.schedule(0, "delete");
					
					return;
				}
				
				if(getTrustLevel(%trigger.parent, %client.player) < 1)
				{
					commandToClient(%client, 'centerPrint', (getBrickGroupFromObject(%trigger.parent).name $= "") ? "\c1BL_ID:" SPC getBrickGroupFromObject(%trigger.parent).bl_id : getBrickGroupFromObject(%trigger.parent).name SPC "\c0does not trust you enough to do that.", 1);
					
					%brick.schedule(0, "delete");
					
					return;
				}
			}
		}
		
		if(!%client.isAdmin && %brick.getDatablock().CityRPBrickAdmin)
		{
			commandToClient(%client, 'centerPrint', "\c3You must be admin to plant this brick!", 3);
			
			%brick.schedule(0, "delete");
			
			return;
		}
		
		if(!%client.isAdmin && !isObject(%trigger) && %brick.getDatablock().CityRPBrickType != 1)
		{
			%brick.schedule(0, "delete");
			
			return;
		}
		
		if(%brick.getDatablock().CityRPBrickType == 1)
		{
			if(CityRPData.getData(%client.bl_id).valueMoney < mFloor(%brick.getDatablock().initialPrice))
			{
				messageClient(%client, '', "\c6You need at least \c3$" @ mFloor(%brick.getDatablock().initialPrice) SPC "\c6in order to plant this lot!");
				
				%brick.schedule(0, "delete");
				
				return;
			}
			
			messageClient(%client, '', "\c6You have paid \c3$" @ mFloor(%brick.getDatablock().initialPrice) @ "\c6 to plant this lot.");
			
			CityRPData.getData(%client.bl_id).valueMoney -= mFloor(%brick.getDatablock().initialPrice);
		}
		
		if(!isObject(CityRPData.getData(getBrickGroupFromObject(%brick).bl_id)))
		{
			CityRPData.addData(getBrickGroupFromObject(%brick).bl_id);
		}
		
		if(%brick.getDatablock().brickType == 2)
		{
			if(CityRPData.getData(%client.bl_id).valueMoney < mFloor($CityRP::prices::vehicleSpawn))
			{
				messageClient(%client, '', "\c6You need at least \c3$" @ mFloor($CityRP::prices::vehicleSpawn) SPC "\c6in order to plant this vehicle spawn!");
				
				%brick.schedule(0, "delete");
				
				return;
			}
			
			messageClient(%client, '', "\c6You have paid \c3$" @ mFloor($CityRP::prices::vehicleSpawn) @ "\c6 to plant this vehicle spawn.");
			
			CityRPData.getData(%client.bl_id).valueMoney -= mFloor($CityRP::prices::vehicleSpawn);
		}
		
		if(%brick.getDatablock().CityRPBrickType == 1 || %brick.getDatablock().CityRPBrickType == 2)
		{
			%brick.schedule(0, "CityRP", 1);
		}
		
		if(%brick.getDatablock().CityRPBrickType == 3)
		{
			$CityRP_temp::spawnPoints = ($CityRP_temp::spawnPoints $= "") ? %brick : $CityRP_temp::spawnPoints SPC %brick;
		}
		
		%client.CityRP(1);
	}
	
	function fxDtsBrick::onDeath(%brick)
	{
		if(%brick.getDatablock().CityRPBrickType == 1 || %brick.getDatablock().CityRPBrickType == 2)
		{
			%brick.CityRP(2);
		}
		
		if(%brick.getDatablock().CityRPBrickType == 3)
		{
			if(getWord($CityRP_temp::spawnPoints, 0) == %brick)
			{
				$CityRP_temp::spawnPoints = strReplace($CityRP_temp::spawnPoints, %brick @ ((getWordCount($CityRP_temp::spawnPoints) == 1) ? "" : " "), "");
			}
			else
			{
				$CityRP_temp::spawnPoints = strReplace($CityRP_temp::spawnPoints, " " @ %brick, "");
			}
		}
		
		parent::onDeath(%brick);
	}
	
	function fxDtsBrick::onRemove(%brick)
	{
		if(%brick.getDatablock().CityRPBrickType == 1 || %brick.getDatablock().CityRPBrickType == 2)
		{
			%brick.CityRP(2);
		}
		
		if(%brick.getDatablock().CityRPBrickType == 3)
		{
			if(getWord($CityRP_temp::spawnPoints, 0) == %brick)
			{
				$CityRP_temp::spawnPoints = strReplace($CityRP_temp::spawnPoints, %brick @ ((getWordCount($CityRP_temp::spawnPoints) == 1) ? "" : " "), "");
			}
			else
			{
				$CityRP_temp::spawnPoints = strReplace($CityRP_temp::spawnPoints, " " @ %brick, "");
			}
		}
		
		parent::onRemove(%brick);
	}
	
	function fxDtsBrick::setName(%brick, %name)
	{
		%oldName = %brick.getName();
		
		if(isObject(%name) && (%brick.getDatablock().CityRPBrickType == 1 || %name.getDatablock().CityRPBrickType == 1))
		{
			%a = 2;
			
			while(isObject(%name @ %a))
			{
				%a++;
			}
			
			%name = %name @ %a;
			
			parent::setName(%brick, %name);
			
			return;
		}
		
		parent::setName(%brick, %name);
		
		if(%name !$= "")
		{
			for(%a = 1; %a <= CityRPData.dataCount; %a++)
			{
				if(getWord(CityRPData.data[%a].valueLotData, 0) == 0)
				{
					continue;
				}
				
				%data = CityRPData.data[%a].valueLotData;
				
				for(%b = 1; %b < getWordCount(%data); %b++)
				{
					if(%b % 2 == 0)
					{
						continue;
					}
					
					if(strLwr(getWord(%data, %b)) $= strLwr(getSubStr(%name, 1, strLen(%name) - 1)))
					{
						%a = 2;
						
						while(isObject(%name @ %a))
						{
							%a++;
						}
						
						%name = %name @ %a;
						
						parent::setName(%brick, %name);
						
						return;
					}
				}
			}
		}
		
		if(%oldName !$= "")
		{
			if(%brick.getName() $= "")
			{
				%data = CityRPData.getData(getBrickGroupFromObject(%brick).bl_id).valueLotData;
				
				%newData = getWord(%data, 0) - 1;
				
				for(%a = 1; %a < getWordCount(%data); %a++)
				{
					if(%cancelNext)
					{
						%cancelNext = false;
						
						continue;
					}
					
					%newData = %newData SPC getWord(%data, %a);
					
					if(%a % 2 == 0)
					{
						continue;
					}
					
					%newBrick = "_" @ getWord(%data, %a);
					
					if(isObject(%newBrick) && %newBrick $= %oldName)
					{
						%newData = getWords(%newData, 0, getWordCount(%newData) - 2);
						
						%cancelNext = true;
					}
				}
				
				CityRPData.getData(getBrickGroupFromObject(%brick).bl_id).valueLotData = %newData;
			}
			else
			{
				CityRPData.getData(getBrickGroupFromObject(%brick).bl_id).valueLotData = strReplace(CityRPData.getData(getBrickGroupFromObject(%brick).bl_id).valueLotData, getSubStr(%oldName, 1, strLen(%oldName) - 1), getSubStr(%name, 1, strLen(%name) - 1));
			}
		}
	}
	
	function fxDtsBrick::setItem(%brick, %datablock, %client)
	{
		if(!isObject(%client))
		{
			%client = getBrickGroupFromObject(%brick).client;
		}
		
		if(!isObject(%client))
		{
			parent::spawnItem(%brick, %pos, %datablock, %client);
			
			return;
		}
		
		if(!isObject(%client) || (isObject($loadingBricks_client) && !isObject($loadBrick_fileObj)) || (isObject(%brick.item) && %brick.item.getDatablock() == %datablock))
		{
			parent::setItem(%brick, %datablock, %client);
			
			return;
		}
		
		if(!%datablock.CityRPCanSpawn && %datablock.CityRPCanSpawn !$= "")
		{
			return;
		}
		
		if(!isObject(%datablock) || (!%client.isAdmin && $CityRP::jobs::items[CityRPData.getData(%client.bl_id).valueJobID] == 0))
		{
			parent::setItem(%brick, 0, %client);
			
			return;
		}
		
		%price = (isObject(%datablock.image) && isObject(%datablock.image.projectile)) ? mFloor(%datablock.image.projectile.directDamage) : 0;
		%price2 = (isObject(%datablock.image) && isObject(%datablock.image.projectile) && isObject(%datablock.image.projectile.explosion)) ? mFloor(%datablock.image.projectile.explosion.radiusDamage) : 0;
		
		if((CityRPData.getData(%client.bl_id).valueMoney - ($CityRP::prices::addItemSpawn + (%price + %price2))) < 0)
		{
			messageClient(%client, '', "\c6You can't afford to spawn this item.");
			
			return;
		}
		
		messageClient(%client, '', "\c6You have paid \c3$" @ ($CityRP::prices::addItemSpawn + (%price + %price2)) @ "\c6 to spawn this item.");
		
		CityRPData.getData(%client.bl_id).valueMoney -= $CityRP::prices::addItemSpawn + (%price + %price2);
		
		%client.CityRP(1);
		
		parent::setItem(%brick, %datablock, %client);
	}
	
	function fxDtsBrick::spawnItem(%brick, %pos, %datablock, %client)
	{
		if(!isObject(%client))
		{
			%client = getBrickGroupFromObject(%brick).client;
		}
		
		if(!isObject(%client))
		{
			parent::spawnItem(%brick, %pos, %datablock, %client);
			
			return;
		}
		
		if(!isObject(%datablock) || (!%client.isAdmin && !$CityRP::jobs::items[CityRPData.getData(%client.bl_id).valueJobID]))
		{
			return;
		}
		
		if(!%datablock.CityRPCanSpawn && %datablock.CityRPCanSpawn !$= "")
		{
			return;
		}
		
		%price = (isObject(%datablock.image) && isObject(%datablock.image.projectile)) ? mFloor(%datablock.image.projectile.directDamage) : 0;
		%price2 = (isObject(%datablock.image) && isObject(%datablock.image.projectile) && isObject(%datablock.image.projectile.explosion)) ? mFloor(%datablock.image.projectile.explosion.radiusDamage) : 0;
		
		if((CityRPData.getData(%client.bl_id).valueMoney - ($CityRP::prices::addItemSpawn + (%price + %price2))) < 0)
		{
			messageClient(%client, '', "\c6You can't afford to spawn this item.");
			
			return;
		}
		
		messageClient(%client, '', "\c6You have paid \c3$" @ ($CityRP::prices::addItemSpawn + (%price + %price2)) @ "\c6 to spawn this item.");
		
		CityRPData.getData(%client.bl_id).valueMoney -= $CityRP::prices::addItemSpawn + (%price + %price2);
		
		%client.CityRP(1);
		
		parent::spawnItem(%brick, %pos, %datablock, %client);
		
		return;
	}
	
	function CityRPLotTriggerData::onEnterTrigger(%this, %trigger, %obj)
	{
		%trigger.parent.onEnterLot(%obj);
		
		if(!isObject(%obj.client))
		{
			return;
		}
		
		%obj.client.CityRPLotTrigger = %trigger;
		
		%obj.client.CityRP(1);
	}
	
	function CityRPLotTriggerData::onLeaveTrigger(%this, %trigger, %obj)
	{
		%trigger.parent.onLeaveLot(%obj);
		
		if(!isObject(%obj.client) || %obj.client.CityRPLotTrigger != %trigger)
		{
			return;
		}
		
		%obj.client.CityRPLotTrigger = "";
		
		%obj.client.CityRP(1);
	}
	
	function CityRPInputTriggerData::onEnterTrigger(%this, %trigger, %obj)
	{
		if(!isObject(%obj.client))
		{
			return;
		}
		
		%obj.client.CityRPTrigger = %trigger;
		
		%trigger.parent.getDatablock().parseData(%trigger.parent, %obj.client, true, "");
	}
	
	function CityRPInputTriggerData::onLeaveTrigger(%this, %trigger, %obj, %a)
	{
		if(!isObject(%obj.client))
		{
			return;
		}
		
		if(%obj.client.CityRPTrigger == %trigger)
		{
			%trigger.parent.getDatablock().parseData(%trigger.parent, %obj.client, false, "");
			
			%obj.client.CityRPTrigger = "";
		}
	}
	
	function fxDTSBrick::onEnterLot(%brick, %obj)
	{
		$inputTarget_self = %brick;
		
		$inputTarget_client = %obj.client;
		$inputTarget_player = %obj.client.player;
		
		$inputTarget_miniGame = (isObject(getMiniGameFromObject(%obj.client))) ? getMiniGameFromObject(%obj.client) : 0;
		
		%brick.processInputEvent("OnEnterLot", %obj.client);
	}
	
	function fxDTSBrick::onLeaveLot(%brick, %obj)
	{
		$inputTarget_self = %brick;
		
		$inputTarget_client = %obj.client;
		$inputTarget_player = %obj.client.player;
		
		$inputTarget_miniGame = (isObject(getMiniGameFromObject(%obj.client))) ? getMiniGameFromObject(%obj.client) : 0;
		
		%brick.processInputEvent("OnLeaveLot", %obj.client);
	}
	
	function weapon::onPickup(%this, %item, %obj)
	{
		parent::onPickup(%this, %item, %obj);
		
		if(isObject(%item.spawnBrick))
		{
			%item.spawnBrick.setItem(0, ((isObject(getBrickGroupFromObject(%item.spawnBrick).client)) ? getBrickGroupFromObject(%item.spawnBrick).client : 0), true);
		}
	}
	
	function itemData::onPickup(%this, %item, %obj)
	{
		parent::onPickup(%this, %item, %obj);
		
		if(isObject(%item.spawnBrick))
		{
			%item.spawnBrick.setItem(0, ((isObject(getBrickGroupFromObject(%item.spawnBrick).client)) ? getBrickGroupFromObject(%item.spawnBrick).client : 0), true);
		}
	}
	
	function player::playThread(%this, %slot, %thread)
	{
		if(%thread $= "armReadyRight" && getWord(CityRPData.getData(%this.client.bl_id).valueJailData, 1) > 0)
		{
			return;
		}
		
		parent::playThread(%this, %slot, %thread);
	}
	
	function player::mountImage(%this, %datablock, %slot)
	{
		if(getWord(CityRPData.getData(%this.client.bl_id).valueJailData, 1) > 0)
		{
			return;
		}
		
		parent::mountImage(%this, %datablock, %slot);
	}
	
	function player::giveDefaultEquipment(%this)
	{
		for(%a = 0; %a < %this.getDatablock().maxTools; %a++)
		{
			if(%a > getWordCount($CityRP::jobs::tools[CityRPData.getData(%this.client.bl_id).valueJobID]) - 1)
			{
				%this.tool[%a] = "";
				
				messageClient(%this.client, 'MsgItemPickup', "", %a, "");
				
				continue;
			}
			
			%this.tool[%a] = nameToID(getWord($CityRP::jobs::tools[CityRPData.getData(%this.client.bl_id).valueJobID], %a));
			
			messageClient(%this.client, 'MsgItemPickup', "", %a, nameToID(getWord($CityRP::jobs::tools[CityRPData.getData(%this.client.bl_id).valueJobID], %a)));
		}
		
		%this.maxWeapons = %this.getDatablock().maxTools;
	}
	
	function player::setDatablock(%this, %datablock)
	{
		if(%datablock != CityRPMini.playerDatablock.getID())
		{
			return;
		}
		
		parent::setDatablock(%this, %datablock);
	}
	
	function player::damage(%this, %obj, %pos, %damage, %damageType)
	{
		if(isObject(%obj) && isObject(%this.client) && isObject(%obj.client) && %this != %obj && %this.getDamageLevel() + %damage < %this.getDatablock().maxDamage && CityRPData.getData(%this.client.bl_id).valueDemerits < $CityRP::demerits::wantedLevel && getWord(CityRPData.getData(%this.client.bl_id).valueJailData, 1) < 1)
		{
			%client = ((%this.getType() & $typeMasks::vehicleObjectType) && isObject(%obj.getControllingClient())) ? %obj.getControllingClient() : %obj.client;
			
			if(%this.getDamageLevel() + %damage < %this.getDatablock().maxDamage)
			{
				commandToClient(%client, 'centerPrint', "\c6You have commited a crime. [\c3Attempted Murder\c6]", 1);
				
				%client.CityRP(2, $CityRP::demerits::attemptedMurder);
			}
		}
		
		parent::damage(%this, %obj, %pos, %damage, %damageType);
	}
	
	function player::activateStuff(%this)
	{
		parent::activateStuff(%this);
		
		%target = containerRayCast(%this.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%this.getEyeVector()), 8), %this.getEyePoint()), $typeMasks::all, %this);
		
		if(isObject(%target) && %target.getType() & $typeMasks::playerObjectType && isObject(%target.client) && getWord(CityRPData.getData(%this.client.bl_id).valueJailData, 1) < 1 && getWord(CityRPData.getData(%target.client.bl_id).valueJailData, 1) < 1 && $CityRP::jobs::pickpocket[CityRPData.getData(%this.client.bl_id).valueJobID] && CityRPData.getData(%target.client.bl_id).valueMoney > 10 && %this.lastPickpocket + 2 < $sim::time)
		{
			%this.lastPickpocket = $sim::time;
			
			if(getRandom(0, 1))
			{
				return;
			}
			
			%amount = getRandom(1, 25);
			
			commandToClient(%this.client, 'centerPrint', "\c6You have commited a crime. [\c3Pickpocketing\c6]", 1);
			
			%this.client.CityRP(2, $CityRP::demerits::pickpocketing);
			
			messageClient(%this.client, '', "\c6You have stolen \c3$" @ %amount SPC "\c6from \c3" @ %target.client.name @ "\c6.");
			messageClient(%target.client, '', "\c3" @ %this.client.name SPC "\c6has stolen \c3$" @ %amount SPC "\c6from you.");
			
			CityRPData.getData(%this.client.bl_id).valueMoney += %amount;
			CityRPData.getData(%target.client.bl_id).valueMoney -= %amount;
			
			if(CityRPData.getData(%target.client.bl_id).valueMoney < 0)
			{
				CityRPData.getData(%target.client.bl_id).valueMoney = 0;
			}
			
			%this.client.CityRP(1);
			%target.client.CityRP(1);
		}
	}
	
	function commandToClient(%client, %command, %arg0, %arg1, %arg2, %arg3, %arg4, %arg5, %arg6, %arg7, %arg8, %arg9, %arg10)
	{
		if(strLwr(getTaggedString(%command)) $= strLwr("bottomPrint") && stripMLControlChars(getWord(%arg0, 0)) !$= "Money:")
		{
			if(%client.CityRPPrintSchedule)
			{
				cancel(%client.CityRPPrintSchedule);
				
				%client.CityRPPrintSchedule = "";
			}
			
			if(!mFloor(%arg1))
			{
				return;
			}
			
			if(mFloor(%arg1))
			{
				%client.CityRPPrintSchedule = %client.schedule(%arg1 * 1000, "CityRP", 1);
			}
		}
		
		parent::commandToClient(%client, %command, %arg0, %arg1, %arg2, %arg3, %arg4, %arg5, %arg6, %arg7, %arg8, %arg9, %arg10);
	}
	
	function CityRPBatonImage::onFire(%this, %obj, %slot)
	{
		parent::onFire(%this, %obj, %slot);
		
		%obj.playThread(2, "armAttack");
	}
	
	function CityRPBatonImage::onStopFire(%this, %obj, %slot)
	{
		%obj.playThread(2, "root");
	}
	
	function CityRPBatonProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
	{
		serverPlay3D(hammerHitSound, %pos);
		
		if((%col.getType() & $typeMasks::fxBrickObjectType))
		{
			if(isObject(%col.door))
			{
				%col.doorOpen();
				
				%col.schedule(3000, "doorClose");
			}
			
			return;
		}
		
		if((%col.getType() & $typeMasks::playerObjectType) && isObject(%col.client))
		{
			if(CityRPData.getData(%col.client.bl_id).valueDemerits < $CityRP::demerits::wantedLevel)
			{
				commandToClient(%obj.client, 'centerPrint', "\c6You have commited a crime. [\c3Hitting Innocents\c6]", 1);
				
				%obj.client.CityRP(2, $CityRP::demerits::hittingInnocents);
				
				return;
			}
			
			if(CityRPData.getData(%col.client.bl_id).valueDemerits >= $CityRP::demerits::wantedLevel)
			{
				%col.client.CityRP(3, %obj.client);
			}
			
			return;
		}
	}
};

package RTB_Goodies
{
	function serverCmdRTB_updatePrefs(%client, %prefArray)
	{
		parent::serverCmdRTB_updatePrefs(%client, %prefArray);
		
		export("$CityRP::*","config/server/PeopleMods/CityRPPrefs.cs");
	}
};

if(!$server::dedicated || $server::lan)
{
	if(!$server::dedicated)
	{
		echo("CityRP does not support non-dedicated servers. Terminating.");
	}
	
	if($server::lan)
	{
		echo("CityRP does not support LAN servers. Terminating.");
	}
	
	eval("package CityRP{function CityRP(){return;}};");
	eval("package RTB_Goodies{function serverCmdRTB_updatePrefs(){parent::serverCmdRTB_updatePrefs(%client, %prefArray);}};");
	
	return;
}

exec("./Sassy.cs");
exec("./Hellen.cs");

if(!$CityRP_temp::loadedDatablocks)
{
	exec("./datablocks.cs");
	
	if(!$CityRP_temp::loadedDatablocks)
	{
		return;
	}
}

activatePackage(CityRP);

CityRP(1);